diff -Nur madwifi-0.9.3.2-rc1.orig/ath/if_ath.c madwifi-0.9.3.2-rc1/ath/if_ath.c
--- madwifi-0.9.3.2-rc1.orig/ath/if_ath.c	2007-07-29 19:12:16.000000000 +0200
+++ madwifi-0.9.3.2-rc1/ath/if_ath.c	2007-07-29 19:18:35.000000000 +0200
@@ -5722,7 +5722,8 @@
 		 * frame; it'll be dropped where it's not wanted.
 		 */
 		if (ds->ds_rxstat.rs_keyix != HAL_RXKEYIX_INVALID &&
-		    (ni = sc->sc_keyixmap[ds->ds_rxstat.rs_keyix]) != NULL) {
+		    ((ni = sc->sc_keyixmap[ds->ds_rxstat.rs_keyix]) != NULL) &&
+ 			ieee80211_check_rxnode(ni, (const struct ieee80211_frame_min *) skb->data)) {
 			struct ath_node *an;
 			/*
 			 * Fast path: node is present in the key map;
diff -Nur madwifi-0.9.3.2-rc1.orig/net80211/ieee80211_node.c madwifi-0.9.3.2-rc1/net80211/ieee80211_node.c
--- madwifi-0.9.3.2-rc1.orig/net80211/ieee80211_node.c	2007-05-23 10:43:05.000000000 +0200
+++ madwifi-0.9.3.2-rc1/net80211/ieee80211_node.c	2007-07-29 19:13:07.000000000 +0200
@@ -1293,8 +1293,6 @@
 	IEEE80211_NODE_UNLOCK_IRQ(nt);
 
 	return ni;
-#undef IS_PSPOLL
-#undef IS_CTL
 }
 #ifdef IEEE80211_DEBUG_REFCNT
 EXPORT_SYMBOL(ieee80211_find_rxnode_debug);
@@ -1302,6 +1300,20 @@
 EXPORT_SYMBOL(ieee80211_find_rxnode);
 #endif
 
+int
+ieee80211_check_rxnode(struct ieee80211_node *ni,
+	const struct ieee80211_frame_min *wh)
+{
+	if (IS_CTL(wh) && !IS_PSPOLL(wh) /*&& !IS_RTS(ah)*/)
+		return IEEE80211_ADDR_EQ(ni->ni_macaddr, wh->i_addr1);
+	else
+		return IEEE80211_ADDR_EQ(ni->ni_macaddr, wh->i_addr2);
+}
+
+EXPORT_SYMBOL(ieee80211_check_rxnode);
+#undef IS_PSPOLL
+#undef IS_CTL
+
 /*
  * Return a reference to the appropriate node for sending
  * a data frame.  This handles node discovery in adhoc networks.
diff -Nur madwifi-0.9.3.2-rc1.orig/net80211/ieee80211_node.h madwifi-0.9.3.2-rc1/net80211/ieee80211_node.h
--- madwifi-0.9.3.2-rc1.orig/net80211/ieee80211_node.h	2007-07-25 17:20:59.000000000 +0200
+++ madwifi-0.9.3.2-rc1/net80211/ieee80211_node.h	2007-07-29 19:16:08.000000000 +0200
@@ -292,6 +292,8 @@
 struct ieee80211_node *ieee80211_find_txnode(struct ieee80211vap *,
 	const u_int8_t *);
 #endif
+int ieee80211_check_rxnode(struct ieee80211_node *ni,
+	const struct ieee80211_frame_min *wh);
 int ieee80211_add_wds_addr(struct ieee80211_node_table *, struct ieee80211_node *,
 	const u_int8_t *, u_int8_t);
 void ieee80211_remove_wds_addr(struct ieee80211_node_table *, const u_int8_t *);
